% "CM" means connectivity matrix. 
% "btk_route" computes all the paths connecting "s" to "d".
% "x" is a cell array consisting of row number sequences.
% The row number sequences correspond to the above paths between "s" to "d".
function x = btk_route(CM, s, d)
if ( nargin == 1 )
     s=input('start point=?');
     d=input('destination=?');
elseif ( nargin == 2 )
     error;
elseif ( nargin == 0 )
     error;
elseif ( nargin >= 4 )
     error;
end
v = find( CM(:,1) == s );
if ( isempty(v) == 0 )
     vs = v( find( CM(v,2) ~= d ), 1);
     vd = v( find( CM(v,2) == d ), 1);
     i0 = 1;
     if ( isempty(vd) == 0 )
           [vdr, vdc] = size(vd);
           while ( i0 <= vdr )
                 x{i0,1} = vd(i0,1);
                 i0 = i0 + 1;
           end
     end
     PO = vs;
     if ( isempty(PO) == 0 )
           while (1)
                 [POr, POc] = size(PO);
                 i1 = 1;
                 vpn = [];
                 while ( i1 <= POr )
                       v0 = find( CM(PO(i1,POc),2) == CM(:,1) );
                       [v0r, v0c] = size(v0);
                       v0i = 1;
                       while ( v0i <= v0r )
                           if ~( any( CM(PO(i1,:),1) == CM(v0(v0i,1),1) ) );
                               vpn = [ vpn; i1, v0(v0i,1) ];
                           end
                           v0i = v0i + 1;
                       end
                       i1 = i1 + 1;
                 end
                 if ( isempty(vpn) == 0 )
                       vs = find( CM(vpn(:,2),2) ~= d );
                       vd = find( CM(vpn(:,2),2) == d );
                       if ( isempty(vd) == 0 )
                             [vdr, vdc] = size(vd);
                             vdi = 1;
                             while ( vdi <= vdr )
                                   x{i0,1} = [ PO(vpn(vd(vdi,1),1),:), vpn(vd(vdi,1),2) ];
                                   i0 = i0 + 1;
                                   vdi = vdi + 1;
                             end 
                       end
                       if ( isempty(vs) == 0 )
                             PO = [ PO(vpn(vs,1),:), vpn(vs,2) ];
                       else
                             PO = [];
                       end
                 else
                       PO = [];
                 end
                 if ( isempty(PO) == 1 )
                       break;
                 end
           end
     end
end